<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>polylib: types.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
<h1>types.h</h1><a href="types_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of PolyLib.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    PolyLib is free software: you can redistribute it and/or modify</span>
<a name="l00005"></a>00005 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00006"></a>00006 <span class="comment">    the Free Software Foundation, either version 3 of the License, or</span>
<a name="l00007"></a>00007 <span class="comment">    (at your option) any later version.</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    PolyLib is distributed in the hope that it will be useful,</span>
<a name="l00010"></a>00010 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00011"></a>00011 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00012"></a>00012 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00015"></a>00015 <span class="comment">    along with PolyLib.  If not, see &lt;http://www.gnu.org/licenses/&gt;.</span>
<a name="l00016"></a>00016 <span class="comment">*/</span>
<a name="l00017"></a>00017 
<a name="l00018"></a>00018 <span class="comment">/* types-polylib.h</span>
<a name="l00019"></a>00019 <span class="comment">     COPYRIGHT</span>
<a name="l00020"></a>00020 <span class="comment">          Both this software and its documentation are</span>
<a name="l00021"></a>00021 <span class="comment"></span>
<a name="l00022"></a>00022 <span class="comment">              Copyright 1993, IRISA /Universite de Rennes I - France</span>
<a name="l00023"></a>00023 <span class="comment">              Copyright 1996,1997,1998, Doran Wilde and Vincent Loechner</span>
<a name="l00024"></a>00024 <span class="comment">              All rights reserved.</span>
<a name="l00025"></a>00025 <span class="comment"></span>
<a name="l00026"></a>00026 <span class="comment">          Permission is granted to copy, use, and distribute</span>
<a name="l00027"></a>00027 <span class="comment">          for any commercial or noncommercial purpose under the terms</span>
<a name="l00028"></a>00028 <span class="comment">          of the GNU General Public license, version 2, June 1991</span>
<a name="l00029"></a>00029 <span class="comment">          (see file : LICENSING).</span>
<a name="l00030"></a>00030 <span class="comment">*/</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="preprocessor">#ifndef _types_polylib_h_</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span><span class="preprocessor">#define _types_polylib_h_</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span>
<a name="l00035"></a>00035 <span class="preprocessor">#ifdef GNUMP</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span><span class="preprocessor">#include&lt;gmp.h&gt;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#endif </span>
<a name="l00038"></a>00038 <span class="preprocessor"></span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &lt;limits.h&gt;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">/*********************** USER DEFINES ******************************/</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="comment">/* first parameter name char.  */</span>
<a name="l00044"></a><a class="code" href="types_8h.html#a0983cb88d8aefa8ac53282de30590726">00044</a> <span class="preprocessor">#define FIRST_PARAMETER_NAME &apos;P&apos;</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span>
<a name="l00046"></a>00046 <span class="comment">/******************* END OF USER DEFINES ***************************/</span>
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00049"></a><a class="code" href="types_8h.html#a39e85cb3471b4808b39bdde4fb125cbe">00049</a> <span class="preprocessor">#define PCHAR (FIRST_PARAMETER_NAME-1)</span>
<a name="l00050"></a><a class="code" href="types_8h.html#a7a3726264ecf2f0985882e0c1adb4ddb">00050</a> <span class="preprocessor"></span><span class="preprocessor">#define MAXNOOFRAYS 200 </span>
<a name="l00051"></a>00051 <span class="preprocessor"></span>
<a name="l00052"></a>00052 <span class="preprocessor">#if defined(LINEAR_VALUE_IS_LONGLONG)</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span><span class="preprocessor">#define P_VALUE_FMT &quot;%4lld &quot;</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span><span class="preprocessor">#elif defined(LINEAR_VALUE_IS_LONG)</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span><span class="preprocessor">#define P_VALUE_FMT &quot;%4ld &quot;</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span><span class="preprocessor">#elif defined(LINEAR_VALUE_IS_CHARS)</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span><span class="preprocessor">#define P_VALUE_FMT &quot;%s &quot;</span>
<a name="l00058"></a>00058 <span class="preprocessor"></span><span class="preprocessor">#elif defined(LINEAR_VALUE_IS_INT) </span>
<a name="l00059"></a>00059 <span class="preprocessor"></span><span class="preprocessor">#define P_VALUE_FMT &quot;%4d &quot;</span>
<a name="l00060"></a>00060 <span class="preprocessor"></span><span class="preprocessor">#else  </span><span class="comment">/* GNUMP */</span>
<a name="l00061"></a><a class="code" href="types_8h.html#ae6f16bcd4a42ba51cbb003e3d1e1cde6">00061</a> <span class="preprocessor">#define P_VALUE_FMT &quot;%4s &quot;</span>
<a name="l00062"></a>00062 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00063"></a>00063 <span class="preprocessor"></span>
<a name="l00064"></a>00064 <span class="comment">/* Used in lower_upper_bounds */</span>
<a name="l00065"></a><a class="code" href="types_8h.html#ab3e4132829e88232125e7bf259520a18">00065</a> <span class="preprocessor">#define LB_INFINITY 1</span>
<a name="l00066"></a><a class="code" href="types_8h.html#a629bf0301263815e35636f493380b9dd">00066</a> <span class="preprocessor"></span><span class="preprocessor">#define UB_INFINITY 2</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span>
<a name="l00068"></a>00068 <span class="comment">/* MSB, TOP, and NEXT are defined over integer type, not on value type */</span>
<a name="l00069"></a>00069 <span class="comment">/* Put a one in the most significant bit of an int (portable) */</span>
<a name="l00070"></a><a class="code" href="types_8h.html#a11f27b3b63dfc15c4b4fbb665a3ce3fe">00070</a> <span class="preprocessor">#define MSB ((unsigned)(((unsigned)1)&lt;&lt;(sizeof(int)*8-1)))</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span>
<a name="l00072"></a>00072 <span class="comment">/* Largest representable positive number */</span>
<a name="l00073"></a><a class="code" href="types_8h.html#afc0eef637f1016e8786e45e106a4881e">00073</a> <span class="preprocessor">#define TOP ((int)(MSB-1))</span>
<a name="l00074"></a>00074 <span class="preprocessor"></span>
<a name="l00075"></a>00075 <span class="comment">/* Right shift the one bit in b and increment j if the last bit in b is one */</span>
<a name="l00076"></a><a class="code" href="types_8h.html#a3dd66db5db700555d4e24314974a2ea1">00076</a> <span class="preprocessor">#define NEXT(j,b) { if (!((b)&gt;&gt;=1)) { (b)=MSB; (j)++; } }</span>
<a name="l00077"></a>00077 <span class="preprocessor"></span>
<a name="l00078"></a>00078 <span class="comment">/* Status of last Polyhedron operation */</span>
<a name="l00079"></a>00079 <span class="keyword">extern</span> <span class="keywordtype">int</span> <a class="code" href="errormsg_8c.html#aa587bf4e8c763fa5e95542df7eb070b7">Pol_status</a>;
<a name="l00080"></a>00080 
<a name="l00081"></a><a class="code" href="types_8h.html#a827ee0a650c714bebc02dfa7da978b5f">00081</a> <span class="preprocessor">#define POL_HIGH_BIT    (UINT_MAX - (UINT_MAX &gt;&gt; 1))</span>
<a name="l00082"></a><a class="code" href="types_8h.html#a754586a0aee88f21ad4c98b1cddee1be">00082</a> <span class="preprocessor"></span><span class="preprocessor">#define POL_NO_DUAL     (POL_HIGH_BIT | 0x0001)</span>
<a name="l00083"></a><a class="code" href="types_8h.html#ad8b11210e90424f4d7be767b93ae2f72">00083</a> <span class="preprocessor"></span><span class="preprocessor">#define POL_INTEGER     (POL_HIGH_BIT | 0x0002)</span>
<a name="l00084"></a><a class="code" href="types_8h.html#a223261a4719dd67ef2048c192bb34099">00084</a> <span class="preprocessor"></span><span class="preprocessor">#define POL_ISSET(flags,f)  ((flags &amp; f) == f)</span>
<a name="l00085"></a>00085 <span class="preprocessor"></span>
<a name="l00086"></a><a class="code" href="structVector.html">00086</a> <span class="keyword">typedef</span> <span class="keyword">struct  </span>{
<a name="l00087"></a><a class="code" href="structVector.html#a424501dd99036dd1dc1c4e009c5b00f9">00087</a>   <span class="keywordtype">unsigned</span> Size;
<a name="l00088"></a><a class="code" href="structVector.html#aecf9fddd3ad47d143da2e041fdff37cc">00088</a>   Value *<a class="code" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>;
<a name="l00089"></a>00089 } <a class="code" href="structVector.html">Vector</a>;
<a name="l00090"></a>00090 
<a name="l00091"></a><a class="code" href="structmatrix.html">00091</a> <span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="structmatrix.html">matrix</a> {
<a name="l00092"></a><a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">00092</a>   <span class="keywordtype">unsigned</span> <a class="code" href="structmatrix.html#a16ad614d15c6e81c0041e877b623c72d">NbRows</a>, <a class="code" href="structmatrix.html#a68858fd3b57684ef38bdfce13c65d182">NbColumns</a>;
<a name="l00093"></a><a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">00093</a>   Value **<a class="code" href="structmatrix.html#a2c6d840d8d911ae95c2ae4fc96f4b5ba">p</a>;
<a name="l00094"></a><a class="code" href="structmatrix.html#a9c294a3fd4d273963e27a0c8cd819bd5">00094</a>   Value *<a class="code" href="structmatrix.html#a9c294a3fd4d273963e27a0c8cd819bd5">p_Init</a>;
<a name="l00095"></a><a class="code" href="structmatrix.html#a5dc523eba55ca76f0a7eba9ec325cbe5">00095</a>   <span class="keywordtype">int</span> <a class="code" href="structmatrix.html#a5dc523eba55ca76f0a7eba9ec325cbe5">p_Init_size</a>;      <span class="comment">/* needed to free the memory allocated by mpz_init */</span>
<a name="l00096"></a>00096 } <a class="code" href="structmatrix.html">Matrix</a>;
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 <span class="comment">/* Macros to init/set/clear/test flags. */</span>
<a name="l00099"></a><a class="code" href="types_8h.html#acd3e6da08aea98ada4bad87b9a63a4e0">00099</a> <span class="preprocessor">#define FL_INIT(l, f)   (l) = (f)               </span><span class="comment">/* Specific flags location. */</span>
<a name="l00100"></a><a class="code" href="types_8h.html#ad564ff71777a709191756eacebd5721a">00100</a> <span class="preprocessor">#define FL_SET(l, f)    ((l) |= (f))</span>
<a name="l00101"></a><a class="code" href="types_8h.html#a287b3b51b0f3bf633e9f00d23b69da46">00101</a> <span class="preprocessor"></span><span class="preprocessor">#define FL_CLR(l, f)    ((l) &amp;= ~(f))</span>
<a name="l00102"></a><a class="code" href="types_8h.html#af6497c16618b94a803a1b43f31629f9c">00102</a> <span class="preprocessor"></span><span class="preprocessor">#define FL_ISSET(l, f)  ((l) &amp; (f))</span>
<a name="l00103"></a>00103 <span class="preprocessor"></span>
<a name="l00104"></a><a class="code" href="types_8h.html#a5283dcd004bd2fcfaab76b89c6c9322b">00104</a> <span class="preprocessor">#define F_INIT(p, f)    FL_INIT((p)-&gt;flags, f)  </span><span class="comment">/* Structure element flags. */</span>
<a name="l00105"></a><a class="code" href="types_8h.html#ab04b7b56e2789336fbc544896cb477f9">00105</a> <span class="preprocessor">#define F_SET(p, f)     FL_SET((p)-&gt;flags, f)</span>
<a name="l00106"></a><a class="code" href="types_8h.html#abf7ccc8dc487c568afdb1efd664d1e61">00106</a> <span class="preprocessor"></span><span class="preprocessor">#define F_CLR(p, f)     FL_CLR((p)-&gt;flags, f)</span>
<a name="l00107"></a><a class="code" href="types_8h.html#a19f1ae711bb0e3063ba1962cb8a898a0">00107</a> <span class="preprocessor"></span><span class="preprocessor">#define F_ISSET(p, f)   FL_ISSET((p)-&gt;flags, f)</span>
<a name="l00108"></a>00108 <span class="preprocessor"></span>
<a name="l00109"></a><a class="code" href="structpolyhedron.html">00109</a> <span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="structpolyhedron.html">polyhedron</a> { 
<a name="l00110"></a><a class="code" href="structpolyhedron.html#a74cba037f5ac1c7182bf960d79d3f124">00110</a>   <span class="keywordtype">unsigned</span> <a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>, <a class="code" href="structpolyhedron.html#a2db05293e731089b9198d45cf027bd1c">NbConstraints</a>, <a class="code" href="structpolyhedron.html#a74cba037f5ac1c7182bf960d79d3f124">NbRays</a>, <a class="code" href="structpolyhedron.html#af316f6440017b2e02fa3a387b2818cc9">NbEq</a>, <a class="code" href="structpolyhedron.html#a9e7c80deeddf472a57bd54217f75c717">NbBid</a>;
<a name="l00111"></a><a class="code" href="structpolyhedron.html#ab2691b8eb5d2dc43a509ac2094d2bc73">00111</a>   Value **<a class="code" href="structpolyhedron.html#ab2691b8eb5d2dc43a509ac2094d2bc73">Constraint</a>;
<a name="l00112"></a><a class="code" href="structpolyhedron.html#a1332db86327e189effc8798ab230f36a">00112</a>   Value **<a class="code" href="structpolyhedron.html#a1332db86327e189effc8798ab230f36a">Ray</a>;
<a name="l00113"></a><a class="code" href="structpolyhedron.html#a3681618067c7bf2a0bd5e805871283f5">00113</a>   Value *<a class="code" href="structpolyhedron.html#a3681618067c7bf2a0bd5e805871283f5">p_Init</a>;
<a name="l00114"></a><a class="code" href="structpolyhedron.html#ac2aa52aede2212101bd130ba7a67663a">00114</a>   <span class="keywordtype">int</span> <a class="code" href="structpolyhedron.html#ac2aa52aede2212101bd130ba7a67663a">p_Init_size</a>;
<a name="l00115"></a><a class="code" href="structpolyhedron.html#aab97126cb9e56431d40eaf4e68b3953d">00115</a>   <span class="keyword">struct </span><a class="code" href="structpolyhedron.html">polyhedron</a> *<a class="code" href="structpolyhedron.html#aab97126cb9e56431d40eaf4e68b3953d">next</a>;
<a name="l00116"></a><a class="code" href="types_8h.html#a1869e11b8e9a1e9e89e8145c242e0eea">00116</a> <span class="preprocessor">#define    POL_INEQUALITIES     0x00000001</span>
<a name="l00117"></a><a class="code" href="types_8h.html#adef192e3530c5e1fcb2c44858a78f703">00117</a> <span class="preprocessor"></span><span class="preprocessor">#define    POL_FACETS           0x00000002</span>
<a name="l00118"></a><a class="code" href="types_8h.html#aacccb2db7ed6cb45d5e324216aa5ea3f">00118</a> <span class="preprocessor"></span><span class="preprocessor">#define    POL_POINTS           0x00000004</span>
<a name="l00119"></a><a class="code" href="types_8h.html#a18cb4aab2aec424306ea8f67f6dfc9b0">00119</a> <span class="preprocessor"></span><span class="preprocessor">#define    POL_VERTICES         0x00000008</span>
<a name="l00120"></a>00120 <span class="preprocessor"></span><span class="comment">/* The flags field contains &quot;valid&quot; information,</span>
<a name="l00121"></a>00121 <span class="comment"> * i.e., the structure was created by PolyLib.</span>
<a name="l00122"></a>00122 <span class="comment"> */</span>
<a name="l00123"></a><a class="code" href="types_8h.html#a2ac4c28a3acbe4578e03ad20db7939cc">00123</a> <span class="preprocessor">#define    POL_VALID            0x00000010</span>
<a name="l00124"></a><a class="code" href="structpolyhedron.html#ac1fb864c352ef93ef3030c35e98c2aed">00124</a> <span class="preprocessor"></span>  <span class="keywordtype">unsigned</span> <a class="code" href="structpolyhedron.html#ac1fb864c352ef93ef3030c35e98c2aed">flags</a>;
<a name="l00125"></a>00125 } <a class="code" href="structpolyhedron.html">Polyhedron</a>;
<a name="l00126"></a>00126 
<a name="l00127"></a><a class="code" href="structinterval.html">00127</a> <span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="structinterval.html">interval</a> {
<a name="l00128"></a><a class="code" href="structinterval.html#a3af72063ac42a7959562dd87586acb70">00128</a>   Value <a class="code" href="structinterval.html#a3af72063ac42a7959562dd87586acb70">MaxN</a>, <a class="code" href="structinterval.html#aec5d91911af4c48d899c363c1637b6fe">MaxD</a>;
<a name="l00129"></a><a class="code" href="structinterval.html#a671bae1e764608a6f6da4449f8158098">00129</a>   Value <a class="code" href="structinterval.html#a671bae1e764608a6f6da4449f8158098">MinN</a>, <a class="code" href="structinterval.html#a0470f7cbd4da9aa8b77a579af53c65a3">MinD</a>; 
<a name="l00130"></a><a class="code" href="structinterval.html#a4a85bcb34b14c468511a4a783673bfcb">00130</a>   <span class="keywordtype">int</span> <a class="code" href="structinterval.html#a0bcde6d5bb239a8786de8401adf60489">MaxI</a>, <a class="code" href="structinterval.html#a4a85bcb34b14c468511a4a783673bfcb">MinI</a>;
<a name="l00131"></a>00131 } <a class="code" href="structinterval.html">Interval</a>;
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 <span class="comment">/* Test whether P is an empty polyhedron */</span>
<a name="l00134"></a><a class="code" href="types_8h.html#a156641ae25106f9a6ac5c5c2a624c168">00134</a> <span class="preprocessor">#define emptyQ(P)                                                       \</span>
<a name="l00135"></a>00135 <span class="preprocessor">        ((F_ISSET(P, POL_INEQUALITIES) &amp;&amp; P-&gt;NbEq &gt; P-&gt;Dimension) ||    \</span>
<a name="l00136"></a>00136 <span class="preprocessor">         (F_ISSET(P, POL_POINTS) &amp;&amp; P-&gt;NbRays == 0))</span>
<a name="l00137"></a>00137 <span class="preprocessor"></span>
<a name="l00138"></a>00138 <span class="comment">/* Test whether P is a universe polyheron */</span>
<a name="l00139"></a><a class="code" href="types_8h.html#a355595bc9326db6a3ec78b2e5c2a0f97">00139</a> <span class="preprocessor">#define universeQ(P) (P-&gt;Dimension==P-&gt;NbBid)</span>
<a name="l00140"></a>00140 <span class="preprocessor"></span>
<a name="l00141"></a><a class="code" href="struct__Param__Vertex.html">00141</a> <span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="struct__Param__Vertex.html">_Param_Vertex</a> {          
<a name="l00142"></a><a class="code" href="struct__Param__Vertex.html#ad61ebc6810df483f7b0e25fea5c6cdf1">00142</a>   <a class="code" href="structmatrix.html">Matrix</a> *<a class="code" href="struct__Param__Vertex.html#ad61ebc6810df483f7b0e25fea5c6cdf1">Vertex</a>; <span class="comment">/* Each row is a coordinate of the vertex. The first  */</span>
<a name="l00143"></a>00143                   <span class="comment">/* &quot;m&quot; values of each row are the coefficients of the */</span>
<a name="l00144"></a>00144                   <span class="comment">/* parameters. The (m+1)th value is the constant, the */</span>
<a name="l00145"></a>00145                   <span class="comment">/* The (m+2)th value is the common denominator.       */</span>
<a name="l00146"></a><a class="code" href="struct__Param__Vertex.html#a09d8d34daf37b7cbcff6761b80761f26">00146</a>   <a class="code" href="structmatrix.html">Matrix</a> *<a class="code" href="struct__Param__Vertex.html#a09d8d34daf37b7cbcff6761b80761f26">Domain</a>; <span class="comment">/* Constraints on parameters (in Polyhedral format)   */</span>
<a name="l00147"></a><a class="code" href="struct__Param__Vertex.html#af7ff9a4be6a5202a9bcf741a8b233c9e">00147</a>   <span class="keywordtype">unsigned</span> *<a class="code" href="struct__Param__Vertex.html#af7ff9a4be6a5202a9bcf741a8b233c9e">Facets</a>; <span class="comment">/* Bit array of facets defining the vertex.         */</span>
<a name="l00148"></a><a class="code" href="struct__Param__Vertex.html#a1115989a70826c590a1c71923cdeee68">00148</a>   <span class="keyword">struct </span><a class="code" href="struct__Param__Vertex.html">_Param_Vertex</a> *<a class="code" href="struct__Param__Vertex.html#a1115989a70826c590a1c71923cdeee68">next</a>;          <span class="comment">/* Pointer to the next structure */</span>
<a name="l00149"></a>00149 } <a class="code" href="struct__Param__Vertex.html">Param_Vertices</a>;
<a name="l00150"></a>00150 
<a name="l00151"></a><a class="code" href="struct__Param__Domain.html">00151</a> <span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="struct__Param__Domain.html">_Param_Domain</a> {
<a name="l00152"></a><a class="code" href="struct__Param__Domain.html#ac87a60cf654cb9b80ddcac469d6ee81a">00152</a>   <span class="keywordtype">unsigned</span> *<a class="code" href="struct__Param__Domain.html#ac87a60cf654cb9b80ddcac469d6ee81a">F</a>;         <span class="comment">/* Bit array of faces */</span>
<a name="l00153"></a><a class="code" href="struct__Param__Domain.html#aac7b708b50ebee4352fddebed2eaba7c">00153</a>   <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="struct__Param__Domain.html#aac7b708b50ebee4352fddebed2eaba7c">Domain</a>;  <span class="comment">/* Pointer to Domain (constraints on parameters) */</span>
<a name="l00154"></a><a class="code" href="struct__Param__Domain.html#a5e0de697b290be8c04aeb01af780c557">00154</a>   <span class="keyword">struct </span><a class="code" href="struct__Param__Domain.html">_Param_Domain</a> *<a class="code" href="struct__Param__Domain.html#a5e0de697b290be8c04aeb01af780c557">next</a>; <span class="comment">/* Pointer to the next structure  */</span>
<a name="l00155"></a>00155 } <a class="code" href="struct__Param__Domain.html">Param_Domain</a>;
<a name="l00156"></a>00156 
<a name="l00157"></a><a class="code" href="struct__Param__Polyhedron.html">00157</a> <span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="struct__Param__Polyhedron.html">_Param_Polyhedron</a> {
<a name="l00158"></a><a class="code" href="struct__Param__Polyhedron.html#abaa0a017c7bef81b5ed9f6d2fd3f6f58">00158</a>         <span class="keywordtype">int</span> <a class="code" href="struct__Param__Polyhedron.html#abaa0a017c7bef81b5ed9f6d2fd3f6f58">nbV</a>;            <span class="comment">/* Number of parameterized vertices            */</span>
<a name="l00159"></a><a class="code" href="struct__Param__Polyhedron.html#a183b47f3f8b8c27079a840c934e7b972">00159</a>         <a class="code" href="struct__Param__Vertex.html">Param_Vertices</a> *<a class="code" href="struct__Param__Polyhedron.html#a183b47f3f8b8c27079a840c934e7b972">V</a>;  <span class="comment">/* Pointer to the list of parameteric vertices */</span>
<a name="l00160"></a><a class="code" href="struct__Param__Polyhedron.html#a23eb52a684bb212c4cf1fbcbd9db066c">00160</a>         <a class="code" href="struct__Param__Domain.html">Param_Domain</a> *<a class="code" href="struct__Param__Polyhedron.html#a23eb52a684bb212c4cf1fbcbd9db066c">D</a>;    <span class="comment">/* Pointer to the list of validity domains     */</span>
<a name="l00161"></a><a class="code" href="struct__Param__Polyhedron.html#ac89157421ffc9312f82b11cb89a05dfe">00161</a>         <a class="code" href="structmatrix.html">Matrix</a> *<a class="code" href="struct__Param__Polyhedron.html#ac89157421ffc9312f82b11cb89a05dfe">Constraints</a>;<span class="comment">/* Constraints referred to by V-&gt;Facets        */</span>
<a name="l00162"></a><a class="code" href="struct__Param__Polyhedron.html#a3daced8ddb352cfa5ed1eeb949f102c5">00162</a>         <a class="code" href="structmatrix.html">Matrix</a> *<a class="code" href="struct__Param__Polyhedron.html#a3daced8ddb352cfa5ed1eeb949f102c5">Rays</a>;        <span class="comment">/* Lines/rays (non parametric)                 */</span>
<a name="l00163"></a>00163 } <a class="code" href="struct__Param__Polyhedron.html">Param_Polyhedron</a>;
<a name="l00164"></a>00164 
<a name="l00165"></a><a class="code" href="types_8h.html#aea9236e3c02c25e1cb628684409630fc">00165</a> <span class="preprocessor">#define FORALL_PVertex_in_ParamPolyhedron(_V, _D, _P)   \</span>
<a name="l00166"></a>00166 <span class="preprocessor">{     int _i, _ix;                                   \</span>
<a name="l00167"></a>00167 <span class="preprocessor">      unsigned _bx;                                  \</span>
<a name="l00168"></a>00168 <span class="preprocessor">      for( _i=0, _ix=0, _bx=MSB, _V=_P-&gt;V ;            \</span>
<a name="l00169"></a>00169 <span class="preprocessor">           _V &amp;&amp; (_i&lt;_P-&gt;nbV) ; _i++, _V=_V-&gt;next )      \</span>
<a name="l00170"></a>00170 <span class="preprocessor">      {       if (_D-&gt;F[_ix] &amp; _bx)                   \</span>
<a name="l00171"></a>00171 <span class="preprocessor">              {</span>
<a name="l00172"></a>00172 <span class="preprocessor"></span>
<a name="l00173"></a><a class="code" href="types_8h.html#a670b1ea03d880e2595bddca5745df8ec">00173</a> <span class="preprocessor">#define END_FORALL_PVertex_in_ParamPolyhedron  \</span>
<a name="l00174"></a>00174 <span class="preprocessor">              }                                \</span>
<a name="l00175"></a>00175 <span class="preprocessor">              NEXT(_ix, _bx);                  \</span>
<a name="l00176"></a>00176 <span class="preprocessor">      }                                        \</span>
<a name="l00177"></a>00177 <span class="preprocessor">}</span>
<a name="l00178"></a>00178 <span class="preprocessor"></span>
<a name="l00179"></a>00179 <span class="comment">/* Data structures for pseudo-polynomial */</span>
<a name="l00180"></a>00180 
<a name="l00181"></a><a class="code" href="types_8h.html#a01e5f42033d0f34c1a182a25a7409fedaa486649798da33c51389df14eaccd3ce">00181</a> <span class="keyword">typedef</span> <span class="keyword">enum</span> { <a class="code" href="types_8h.html#a01e5f42033d0f34c1a182a25a7409fedaa486649798da33c51389df14eaccd3ce">polynomial</a>, <a class="code" href="types_8h.html#a01e5f42033d0f34c1a182a25a7409feda3cb930eb7594d2236ab4fc6dd622c207">periodic</a>, <a class="code" href="types_8h.html#a01e5f42033d0f34c1a182a25a7409fedacabe6900b0394de2166c488c664bdd6a">evector</a> } <a class="code" href="types_8h.html#a01e5f42033d0f34c1a182a25a7409fed">enode_type</a>;
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 <span class="preprocessor">#ifdef CLN</span>
<a name="l00184"></a>00184 <span class="preprocessor"></span><span class="preprocessor">#define POLY_UNION_OR_STRUCT struct</span>
<a name="l00185"></a>00185 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00186"></a><a class="code" href="types_8h.html#aa4be88adae6068f5be6a24cfc1bfc9ba">00186</a> <span class="preprocessor"></span><span class="preprocessor">#define POLY_UNION_OR_STRUCT union</span>
<a name="l00187"></a>00187 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00188"></a>00188 <span class="preprocessor"></span>
<a name="l00189"></a><a class="code" href="struct__evalue.html">00189</a> <span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="struct__evalue.html">_evalue</a> {
<a name="l00190"></a><a class="code" href="struct__evalue.html#ae4aada7b06d44dcbf9f4d2daf1834e29">00190</a>   Value <a class="code" href="struct__evalue.html#ae4aada7b06d44dcbf9f4d2daf1834e29">d</a>;              <span class="comment">/* denominator */</span>
<a name="l00191"></a>00191   <a class="code" href="types_8h.html#aa4be88adae6068f5be6a24cfc1bfc9ba">POLY_UNION_OR_STRUCT</a> {
<a name="l00192"></a>00192     Value <a class="code" href="polyparam_8c.html#a76f11d9a0a47b94f72c2d0e77fb32240">n</a>;            <span class="comment">/* numerator (if denominator != 0) */</span>
<a name="l00193"></a>00193     <span class="keyword">struct </span><a class="code" href="struct__enode.html">_enode</a> *<a class="code" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>;   <span class="comment">/* pointer   (if denominator == 0) */</span>
<a name="l00194"></a>00194   } x;
<a name="l00195"></a>00195 } <a class="code" href="struct__evalue.html">evalue</a>;
<a name="l00196"></a>00196 
<a name="l00197"></a><a class="code" href="struct__enode.html">00197</a> <span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="struct__enode.html">_enode</a> {
<a name="l00198"></a><a class="code" href="struct__enode.html#a36787a943f0f24530a8934c48a69d282">00198</a>   <a class="code" href="types_8h.html#a01e5f42033d0f34c1a182a25a7409fed">enode_type</a> <a class="code" href="struct__enode.html#a36787a943f0f24530a8934c48a69d282">type</a>;      <span class="comment">/* polynomial or periodic or evector */</span>
<a name="l00199"></a><a class="code" href="struct__enode.html#aba9a89a7893638f2ad9d77c9d0247797">00199</a>   <span class="keywordtype">int</span> <a class="code" href="struct__enode.html#aba9a89a7893638f2ad9d77c9d0247797">size</a>;             <span class="comment">/* number of attached pointers */</span>
<a name="l00200"></a><a class="code" href="struct__enode.html#a1230adfbd7f0ca1f8628a03be4e6ef35">00200</a>   <span class="keywordtype">int</span> <a class="code" href="struct__enode.html#a1230adfbd7f0ca1f8628a03be4e6ef35">pos</a>;              <span class="comment">/* parameter position */</span>
<a name="l00201"></a><a class="code" href="struct__enode.html#a215794f8b8ab87573bd46f14a8e916d4">00201</a>   <a class="code" href="struct__evalue.html">evalue</a> <a class="code" href="struct__enode.html#a215794f8b8ab87573bd46f14a8e916d4">arr</a>[1];        <span class="comment">/* array of rational/pointer */</span>
<a name="l00202"></a>00202 } <a class="code" href="struct__enode.html">enode</a>;
<a name="l00203"></a>00203 
<a name="l00204"></a><a class="code" href="struct__enumeration.html">00204</a> <span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="struct__enumeration.html">_enumeration</a> {
<a name="l00205"></a>00205   
<a name="l00206"></a><a class="code" href="struct__enumeration.html#a57e35419d63ab12898542ef58d8decac">00206</a>   <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="struct__enumeration.html#a57e35419d63ab12898542ef58d8decac">ValidityDomain</a>;    <span class="comment">/* contraints on the parameters     */</span>
<a name="l00207"></a><a class="code" href="struct__enumeration.html#aa499b062a10ce16356e9b52d25cae0d9">00207</a>   <a class="code" href="struct__evalue.html">evalue</a> <a class="code" href="struct__enumeration.html#aa499b062a10ce16356e9b52d25cae0d9">EP</a>;                     <span class="comment">/* dimension = combined space       */</span>
<a name="l00208"></a><a class="code" href="struct__enumeration.html#ad2fd42474e015c9abc6aea0e2bea08b8">00208</a>   <span class="keyword">struct </span><a class="code" href="struct__enumeration.html">_enumeration</a> *<a class="code" href="struct__enumeration.html#ad2fd42474e015c9abc6aea0e2bea08b8">next</a>;     <span class="comment">/* Ehrhart Polynomial, corresponding</span>
<a name="l00209"></a>00209 <span class="comment">                                    to parameter values inside the</span>
<a name="l00210"></a>00210 <span class="comment">                                    domain ValidityDomain below      */</span>
<a name="l00211"></a>00211 } <a class="code" href="struct__enumeration.html">Enumeration</a>;
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 <span class="comment">/*-----------------------------Example Usage------------------------------*/</span>
<a name="l00214"></a>00214 <span class="comment">/* enode *e                                                               */</span>
<a name="l00215"></a>00215 <span class="comment">/*     e-&gt;type = polynomial     e-&gt;type = periodic   e-&gt;type = evector    */</span>
<a name="l00216"></a>00216 <span class="comment">/*     e-&gt;size = degree+1       e-&gt;size = period     e-&gt;size = length     */</span>
<a name="l00217"></a>00217 <span class="comment">/*     e-&gt;pos  = [1..nb_param]                                            */</span>
<a name="l00218"></a>00218 <span class="comment">/*     e-&gt;arr[i].d = denominator (Value)                                  */</span>
<a name="l00219"></a>00219 <span class="comment">/*     e-&gt;arr[i].x.p = pointer to another enode (if denominator is zero)  */</span>
<a name="l00220"></a>00220 <span class="comment">/*     e-&gt;arr[i].x.n = numerator (Value) (if denominator is non-zero)     */</span>
<a name="l00221"></a>00221 <span class="comment">/*------------------------------------------------------------------------*/</span>
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 <span class="comment">/*------------------------------------------------------------------------*/</span>
<a name="l00224"></a>00224 <span class="comment">/* This representation has the following advantages:                      */</span>
<a name="l00225"></a>00225 <span class="comment">/*   -- its dynamic, it can grow/shrink easily                            */</span>
<a name="l00226"></a>00226 <span class="comment">/*   -- it is easy to evaluate for a given context (values of parameters) */</span>
<a name="l00227"></a>00227 <span class="comment">/*   -- it allows pseudo-polynomial to be reduced with rules              */</span>
<a name="l00228"></a>00228 <span class="comment">/*   -- it can be constructed recursively                                 */</span>
<a name="l00229"></a>00229 <span class="comment">/*------------------------------------------------------------------------*/</span>
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 <span class="comment">/* *********************** |Represnting Z-Polyhedron| ******************* */</span>
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 
<a name="l00234"></a><a class="code" href="types_8h.html#a39db6982619d623273fad8a383489309a6d32c34708a0a3507c4bdb89219d650b">00234</a> <span class="keyword">typedef</span> <span class="keyword">enum</span> {<a class="code" href="types_8h.html#a39db6982619d623273fad8a383489309af9d46b7804d93a4fcde88489a1b68c24">False</a> = 0, <a class="code" href="types_8h.html#a39db6982619d623273fad8a383489309a6d32c34708a0a3507c4bdb89219d650b">True</a> = 1} <a class="code" href="types_8h.html#a39db6982619d623273fad8a383489309">Bool</a>;
<a name="l00235"></a><a class="code" href="types_8h.html#ac8d4befd62b1ee6f70e665b1db3192cf">00235</a> <span class="keyword">typedef</span> <a class="code" href="structmatrix.html">Matrix</a> <a class="code" href="structmatrix.html">Lattice</a>;
<a name="l00236"></a><a class="code" href="structLatticeUnion.html">00236</a> <span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="structLatticeUnion.html">LatticeUnion</a> {
<a name="l00237"></a><a class="code" href="structLatticeUnion.html#ab9b004530ace366d12a2cf46e7a13175">00237</a>   <a class="code" href="structmatrix.html">Lattice</a> *<a class="code" href="structLatticeUnion.html#ab9b004530ace366d12a2cf46e7a13175">M</a>;
<a name="l00238"></a><a class="code" href="structLatticeUnion.html#ab21274825bf2e44967e1fcf6f42bcd88">00238</a>   <span class="keyword">struct </span><a class="code" href="structLatticeUnion.html">LatticeUnion</a> *<a class="code" href="structLatticeUnion.html#ab21274825bf2e44967e1fcf6f42bcd88">next</a>;
<a name="l00239"></a>00239 } <a class="code" href="structLatticeUnion.html">LatticeUnion</a>;
<a name="l00240"></a>00240 
<a name="l00241"></a><a class="code" href="structZPolyhedron.html">00241</a> <span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="structZPolyhedron.html">ZPolyhedron</a> {
<a name="l00242"></a><a class="code" href="structZPolyhedron.html#a99898c1e05ac9dd7043b4bb900740b02">00242</a>   <a class="code" href="structmatrix.html">Lattice</a> *<a class="code" href="structZPolyhedron.html#a99898c1e05ac9dd7043b4bb900740b02">Lat</a> ;
<a name="l00243"></a><a class="code" href="structZPolyhedron.html#aa02d9c99e02cb5f77550a865943637af">00243</a>   <a class="code" href="structpolyhedron.html">Polyhedron</a> *<a class="code" href="structZPolyhedron.html#aa02d9c99e02cb5f77550a865943637af">P</a>;
<a name="l00244"></a><a class="code" href="structZPolyhedron.html#a03a31e09bc3818f7b069323376699bb2">00244</a>   <span class="keyword">struct </span><a class="code" href="structZPolyhedron.html">ZPolyhedron</a> *<a class="code" href="structZPolyhedron.html#a03a31e09bc3818f7b069323376699bb2">next</a>;
<a name="l00245"></a>00245 } <a class="code" href="structZPolyhedron.html">ZPolyhedron</a>;
<a name="l00246"></a>00246 
<a name="l00247"></a>00247 <span class="preprocessor">#ifndef FOREVER</span>
<a name="l00248"></a><a class="code" href="types_8h.html#a75c828ed6c02fcd44084e67a032e422c">00248</a> <span class="preprocessor"></span><span class="preprocessor">#define FOREVER for(;;)</span>
<a name="l00249"></a>00249 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00250"></a>00250 <span class="preprocessor"></span>
<a name="l00251"></a>00251 <span class="preprocessor">#endif </span><span class="comment">/* _types_polylib_h_ */</span>
</pre></div></div>
<hr size="1"/><address style="text-align: right;"><small>Generated on Wed Nov 25 17:45:26 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
